package labs12.assignment2.business_logic;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;
import java.awt.event.ActionEvent;

public class CurrencyConverterGUI extends JFrame {

	private JPanel contentPane;
	private JLabel lblAmountInRsd;
	private JLabel lblAmountInEuros;
	private JTextField rsdTextField;
	private JTextField euroTextField;
	private JButton d2eButton;
	private JButton e2dButton;
	private JLabel statusLbl;
	
	private DecimalFormat formatter = new DecimalFormat();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					CurrencyConverterGUI frame = new CurrencyConverterGUI();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public CurrencyConverterGUI() {
		setResizable(false);
		setTitle("Currency Converter");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 353, 224);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		contentPane.add(getLblAmountInRsd());
		contentPane.add(getLblAmountInEuros());
		contentPane.add(getRsdTextField());
		contentPane.add(getEuroTextField());
		contentPane.add(getD2eButton());
		contentPane.add(getE2dButton());
		contentPane.add(getStatusLbl());
	}

	private JLabel getLblAmountInRsd() {
		if (lblAmountInRsd == null) {
			lblAmountInRsd = new JLabel("Amount in RSD");
			lblAmountInRsd.setBounds(30, 48, 103, 22);
		}
		return lblAmountInRsd;
	}
	private JLabel getLblAmountInEuros() {
		if (lblAmountInEuros == null) {
			lblAmountInEuros = new JLabel("Amount in Euros");
			lblAmountInEuros.setBounds(190, 48, 103, 22);
		}
		return lblAmountInEuros;
	}
	private JTextField getRsdTextField() {
		if (rsdTextField == null) {
			rsdTextField = new JTextField();
			rsdTextField.setBounds(30, 81, 103, 20);
			rsdTextField.setColumns(10);
		}
		return rsdTextField;
	}
	private JTextField getEuroTextField() {
		if (euroTextField == null) {
			euroTextField = new JTextField();
			euroTextField.setColumns(10);
			euroTextField.setBounds(190, 81, 103, 20);
		}
		return euroTextField;
	}
	private JButton getD2eButton() {
		if (d2eButton == null) {
			d2eButton = new JButton("Convert D2E");
			d2eButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					String amountStr = rsdTextField.getText();
					try {
						double amount = Double.parseDouble(amountStr);
						double amountEuro = CurrencyConverter.convertRSDToEuros(amount);
						formatter.setMaximumFractionDigits(3);
						euroTextField.setText( formatter.format(amountEuro) );
						statusLbl.setForeground(Color.BLACK);
						statusLbl.setText("Conversion successfully done");
					} catch (NumberFormatException e1) {
						statusLbl.setForeground(Color.RED);
						statusLbl.setText("Invalid input! Cannot proceed!");
						
					}
				}
			});
			d2eButton.setBounds(30, 125, 103, 23);
		}
		return d2eButton;
	}
	private JButton getE2dButton() {
		if (e2dButton == null) {
			e2dButton = new JButton("Convert E2D");
			e2dButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {	
					String amountStr = euroTextField.getText();
					try {
						double amount = Double.parseDouble(amountStr);
						double amountRSD = CurrencyConverter.convertEurosToRSD(amount);
						formatter.setMaximumFractionDigits(3);
						rsdTextField.setText( formatter.format(amountRSD) );
						statusLbl.setForeground(Color.BLACK);
						statusLbl.setText("Conversion successfully done");
					} catch (NumberFormatException e1) {
						statusLbl.setForeground(Color.RED);
						statusLbl.setText("Invalid input! Cannot proceed!");
						
					}
				}
			});
			e2dButton.setBounds(190, 125, 103, 23);
		}
		return e2dButton;
	}
	private JLabel getStatusLbl() {
		if (statusLbl == null) {
			statusLbl = new JLabel("");
			statusLbl.setBounds(30, 174, 266, 14);
		}
		return statusLbl;
	}
}
