package labs12.assignment1;

import java.io.EOFException;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.LinkedList;

public class Group {
	
	private LinkedList<Person> members = new LinkedList<Person>();
	
	public void addMember(Person p) {
		if ( p!= null )
			members.add(p);
	}
	
	public void serializeMembers() {
		try(ObjectOutputStream out = 
				new ObjectOutputStream(
						new FileOutputStream("group.ser"))){
			
			for (Person person : members) {
				out.writeObject(person);
			}
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void deserializeMembers() {
		try(ObjectInputStream in = 
				new ObjectInputStream(
						new FileInputStream("group.ser"))) {
			
			members.clear();
			
			try {
				while(true) {
					Object o = in.readObject();
					members.add((Person)o);
				}
			} catch (EOFException e) {
				System.out.println("Terminating the process; "
						+ "end of file is reached");
			}
			
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void print() {
		for (Person person : members) {
			System.out.println(person.getName() + " " + person.getSurname());
		}
	}

}





