package labs12.assignment2.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import labs12.assignment2.business_logic.CurrencyConverter;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;
import java.awt.event.ActionEvent;

public class ConverterGUI extends JFrame {

	private JPanel contentPane;
	private JLabel lblAmountInRsd;
	private JLabel lblAmountInEuros;
	private JTextField rsdTextField;
	private JTextField euroTextField;
	private JButton d2eButton;
	private JButton e2dButton;
	private JLabel statusLabel;
	
	private DecimalFormat formatter = new DecimalFormat();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					ConverterGUI frame = new ConverterGUI();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public ConverterGUI() {
		setResizable(false);
		setTitle("Currency Converter");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 371, 268);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		contentPane.add(getLblAmountInRsd());
		contentPane.add(getLblAmountInEuros());
		contentPane.add(getRsdTextField());
		contentPane.add(getEuroTextField());
		contentPane.add(getD2eButton());
		contentPane.add(getE2dButton());
		contentPane.add(getStatusLabel());
	}
	private JLabel getLblAmountInRsd() {
		if (lblAmountInRsd == null) {
			lblAmountInRsd = new JLabel("Amount in RSD");
			lblAmountInRsd.setBounds(40, 45, 101, 28);
		}
		return lblAmountInRsd;
	}
	private JLabel getLblAmountInEuros() {
		if (lblAmountInEuros == null) {
			lblAmountInEuros = new JLabel("Amount in Euros");
			lblAmountInEuros.setBounds(222, 45, 101, 28);
		}
		return lblAmountInEuros;
	}
	private JTextField getRsdTextField() {
		if (rsdTextField == null) {
			rsdTextField = new JTextField();
			rsdTextField.setBounds(40, 90, 113, 28);
			rsdTextField.setColumns(10);
		}
		return rsdTextField;
	}
	private JTextField getEuroTextField() {
		if (euroTextField == null) {
			euroTextField = new JTextField();
			euroTextField.setColumns(10);
			euroTextField.setBounds(222, 90, 113, 28);
		}
		return euroTextField;
	}
	private JButton getD2eButton() {
		if (d2eButton == null) {
			d2eButton = new JButton("Convert D2E");
			d2eButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					String amountStr = rsdTextField.getText();
					try {
						double amount = Double.parseDouble(amountStr);
						double amountEuro = 
								CurrencyConverter.convertRSDToEuros(amount);
						
						formatter.setMaximumFractionDigits(4);
						euroTextField.setText( formatter.format(amountEuro) );
						//euroTextField.setText( String.valueOf(amountEuro) ); 
												//amountEuro + ""
						statusLabel.setForeground(Color.BLACK);
						statusLabel.setText("Conversion successful");
					} catch (NumberFormatException e1) {
						statusLabel.setForeground(Color.RED);
						statusLabel.setText("Invalid input; please try again");
					}
				}
			});
			d2eButton.setBounds(40, 150, 113, 23);
		}
		return d2eButton;
	}
	private JButton getE2dButton() {
		if (e2dButton == null) {
			e2dButton = new JButton("Convert E2D");
			e2dButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					String amountStr = euroTextField.getText();
					try {
						double amount = Double.parseDouble(amountStr);
						double amountRSD = 
								CurrencyConverter.convertEurosToRSD(amount);
						
						formatter.setMaximumFractionDigits(4);
						rsdTextField.setText( formatter.format(amountRSD) );
						statusLabel.setForeground(Color.BLACK);
						statusLabel.setText("Conversion successful");
					} catch (NumberFormatException e1) {
						statusLabel.setForeground(Color.RED);
						statusLabel.setText("Invalid input; please try again");
					}
				}
			});
			e2dButton.setBounds(222, 150, 113, 23);
		}
		return e2dButton;
	}
	private JLabel getStatusLabel() {
		if (statusLabel == null) {
			statusLabel = new JLabel("");
			statusLabel.setBounds(40, 201, 296, 31);
		}
		return statusLabel;
	}
}
