package labs12.assignment3.gui;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.text.DecimalFormat;

import labs12.assignment3.business_logic.BMICalculator;

public class BMICalculatorGUI extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	private JLabel lblHeightmeters;
	private JTextField heightTextField;
	private JLabel lblWeightinKg;
	private JTextField weightTextField;
	private JButton btnCalculateBmi;
	private JLabel lblBmi;
	private JTextField bmiTextField;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					BMICalculatorGUI frame = new BMICalculatorGUI();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public BMICalculatorGUI() {
		setResizable(false);
		setTitle("BMI Calculator");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 318, 271);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		contentPane.add(getLblHeightmeters());
		contentPane.add(getHeightTextField());
		contentPane.add(getLblWeightinKg());
		contentPane.add(getWeightTextField());
		contentPane.add(getBtnCalculateBmi());
		contentPane.add(getLblBmi());
		contentPane.add(getBmiTextField());
	}
	private JLabel getLblHeightmeters() {
		if (lblHeightmeters == null) {
			lblHeightmeters = new JLabel("Height (in meters)");
			lblHeightmeters.setBounds(20, 44, 128, 27);
		}
		return lblHeightmeters;
	}
	private JTextField getHeightTextField() {
		if (heightTextField == null) {
			heightTextField = new JTextField();
			heightTextField.setBounds(160, 43, 134, 28);
			heightTextField.setColumns(10);
		}
		return heightTextField;
	}
	private JLabel getLblWeightinKg() {
		if (lblWeightinKg == null) {
			lblWeightinKg = new JLabel("Weight (in kg)");
			lblWeightinKg.setBounds(20, 105, 128, 27);
		}
		return lblWeightinKg;
	}
	private JTextField getWeightTextField() {
		if (weightTextField == null) {
			weightTextField = new JTextField();
			weightTextField.setColumns(10);
			weightTextField.setBounds(160, 104, 134, 28);
		}
		return weightTextField;
	}
	private JButton getBtnCalculateBmi() {
		if (btnCalculateBmi == null) {
			btnCalculateBmi = new JButton("Calculate BMI");
			btnCalculateBmi.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					
					String heightStr = heightTextField.getText();
					String weightStr = weightTextField.getText();
					try {
						double height = Double.parseDouble(heightStr);
						double weight = Double.parseDouble(weightStr);
						double bmi = BMICalculator.calculateBMI(height, weight);
						DecimalFormat formatter = new DecimalFormat();
						formatter.setMaximumFractionDigits(3);
						bmiTextField.setText(formatter.format(bmi));
					} catch (NumberFormatException e1) {
						bmiTextField.setText("Invalid input!");
					}
					
				}
			});
			btnCalculateBmi.setBounds(81, 158, 117, 28);
		}
		return btnCalculateBmi;
	}
	private JLabel getLblBmi() {
		if (lblBmi == null) {
			lblBmi = new JLabel("BMI");
			lblBmi.setBounds(20, 198, 128, 27);
		}
		return lblBmi;
	}
	private JTextField getBmiTextField() {
		if (bmiTextField == null) {
			bmiTextField = new JTextField();
			bmiTextField.setColumns(10);
			bmiTextField.setBounds(160, 198, 134, 28);
		}
		return bmiTextField;
	}
}
